<template>
  <h1>Icons</h1>

  <rui-tabs>
    <rui-button caption="Setup" :active="tab === 'setup'" @click="tab = 'setup'" />
    <rui-button caption="References" :active="tab === 'references'" @click="tab = 'references'" />
    <rui-button caption="Ruby on Rails" :active="tab === 'rails'" @click="tab = 'rails'" />
  </rui-tabs>

  <section v-if="tab === 'setup'">
    <markdown-renderer file="icons-setup" document />
  </section>

  <section v-else-if="tab === 'references'">
    <div class="_filters">
      <div class="_filters__section">
        <div class="_filters__section__title">Search</div>
        <input v-model="searchTerm" type="search">
      </div>
      <div class="_filters__section">
        <div class="_filters__section__title">Size</div>
        <select v-model="size">
          <option value="" />
          <option v-for="val in sizes" :key="val" :value="val">{{ val }}</option>
        </select>
      </div>
    </div>

    <div class="-mtd">
      <div v-for="icon in icons" :key="icon" class="-flex -flex--gap">
        <rui-icon :name="icon" :size="size" />
        <code>{{ icon }}</code>
      </div>
    </div>
  </section>

  <section v-else-if="tab === 'rails'">
    <markdown-renderer file="icons-rails" document />
  </section>
</template>

<script>
import rawIcons from '../../../src/assets/images/icons.svg?raw'
import { sizes } from '../../../src/components/Icon/Icon.vue'
import RuiButton from '../../../src/components/Button/Button.vue'
import MarkdownRenderer from '../components/MarkdownRenderer.vue'

const parser = new DOMParser()
const iconElement = parser.parseFromString(rawIcons, 'image/svg+xml')

const icons = Array.from(iconElement.querySelectorAll('symbol'))
  .map(e => e.id.replace(/^icon-/, ''))
  .sort()

export default {
  name: 'IconsView',
  components: { MarkdownRenderer, RuiButton },
  data () {
    return {
      tab: 'setup',
      // References filters
      searchTerm: '',
      size: null,
      sizes,
    }
  },
  computed: {
    icons () {
      const searchTerm = this.searchTerm.trim()
      if (searchTerm === '') return icons

      return icons.filter(i => i.includes(searchTerm))
    },
  },
  created () {
    this.$setTitle('Icons')
  },
}
</script>
